
#define WINVER          0x0501
#define _WIN32_WINNT    0x0501
#define _WIN32_IE       0x0501

#include <windows.h>
#include <commctrl.h>
#include <tlhelp32.h>
#include <psapi.h>

#ifndef WM_MOUSEHWHEEL
#define WM_MOUSEHWHEEL                  0x020E
#endif

#include "MauHook.h"
#include "../MauSuji/main.h"

#pragma comment(lib, "psapi.lib")

#define NO_HITTEST		-3

#pragma data_seg(".mshared")

HHOOK NextMouseHook = NULL;	//tbNvV[W̃nh
HHOOK NextMessageHook = NULL;
HHOOK NextButtonSearchHook = NULL;
HHOOK KeyBoardHook = NULL;
HHOOK NextLowLevelHook = NULL;
HWND CallWnd = NULL;	//ĂяõEBhEnh
HWND CallDlg1 = NULL;
HWND CallDlg2 = NULL;
HWND hwTarget = NULL;
HWND hCommandDialog = NULL;
HWND hSendKeyCombo = NULL;
HCURSOR hcursor_gesture = NULL;
HCURSOR hcursor_wait = NULL;
BOOL ButtonSearchHook = FALSE;
int WindowHook = 0;
int Cursor = 3;
BOOL ButtonFlag = FALSE;
BOOL HookFlag = TRUE;	//TRUE:tbNL FALSE:tbN
TCHAR TargetPath[_MAX_PATH + 1] = TEXT("");
TCHAR TargetClass[MAX_CLASSNAME + 1] = TEXT("");
TCHAR TargetID[MAX_CLASSNAME + 1] = TEXT("");
int TargetHitTestCode = NO_HITTEST;
BOOL SetTargetFlag = FALSE;
BOOL GetWindowFocusFlag = FALSE;
HWND WindowFocus = NULL;
BOOL WheelRedirectFlag = FALSE;
BOOL X_Button_1 = FALSE;
BOOL X_Button_2 = FALSE;
int ListViewHitTestCode = 0;
int TreeViewHitTestCode = 0;
POINT MousePos = {0, 0};
BOOL ScrollFlag = FALSE;
BOOL WheelActiveFlag = FALSE;
BOOL MessageRedirectFlag = FALSE;
BOOL KuruKuruFlag = FALSE;
BOOL FreeScrollFlag = FALSE;
int ScrollLine = 0;
int ScrollPage = 0;
UINT uMsgSetTarget = 0;
UINT uMsgGetFocus = 0;
#ifdef _WIN64
#else
BOOL Wow64Process = FALSE;
#endif	//_WIN64
BOOL ListViewHitTestCodeFlag = FALSE;
BOOL TreeViewHitTestCodeFlag = FALSE;

#pragma data_seg()


HINSTANCE hInstDLL;		//DLL̃CX^Xnh

//DLLC
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwNotification, LPVOID lpReserved)
{
	UNREFERENCED_PARAMETER(hInstance);
	UNREFERENCED_PARAMETER(lpReserved);

	hInstDLL = hInstance;
	return TRUE;
}

HWND SearchScrollBar(HWND hWnd, LONG_PTR BarStyle)
{
	TCHAR szClassName[256];
	LONG_PTR style;

	hWnd = GetTopWindow(hWnd);//q̍ŏ̃EBh擾
	while(hWnd != NULL)
	{
		GetClassName(hWnd, szClassName, 256);
		if(lstrcmpi(szClassName, TEXT("ScrollBar")) == 0)
		{
			style = GetWindowLongPtr(hWnd, GWL_STYLE);
			if((style & 0x0001) == BarStyle && (style & WS_VISIBLE) && !(style & WS_DISABLED))
			{//XN[o[EBh
				return hWnd;
			}
		}
		hWnd = GetNextWindow(hWnd, GW_HWNDNEXT);
	}
	return NULL;
}

void MouseScroll(int PosX, int PosY) //̏ŃXN[
{
	POINT RealPos;

	GetCursorPos(&RealPos);

	if(abs(MousePos.x - PosX) >= ScrollLine)
	{
		if(abs(MousePos.x - PosX) >= ScrollPage)
		{
			if(MousePos.x > PosX)
				PostMessage(hwTarget, WM_HSCROLL, SB_PAGELEFT, (LPARAM)SearchScrollBar(hwTarget, SBS_HORZ));
			else
				PostMessage(hwTarget, WM_HSCROLL, SB_PAGERIGHT, (LPARAM)SearchScrollBar(hwTarget, SBS_HORZ));
		}
		else
		{
			if(MousePos.x > PosX)
				PostMessage(hwTarget, WM_HSCROLL, SB_LINELEFT, (LPARAM)SearchScrollBar(hwTarget, SBS_HORZ));
			else
				PostMessage(hwTarget, WM_HSCROLL, SB_LINERIGHT, (LPARAM)SearchScrollBar(hwTarget, SBS_HORZ));
		}
		MousePos.x = RealPos.x;
	}
	else
	{
		MousePos.x += (MousePos.x - PosX);
	}

	if(abs(MousePos.y - PosY) >= ScrollLine)
	{
		if(abs(MousePos.y - PosY) >= ScrollPage)
		{
			if(MousePos.y > PosY)
				PostMessage(hwTarget, WM_VSCROLL, SB_PAGEUP, (LPARAM)SearchScrollBar(hwTarget, SBS_VERT));
			else
				PostMessage(hwTarget, WM_VSCROLL, SB_PAGEDOWN, (LPARAM)SearchScrollBar(hwTarget, SBS_VERT));
		}
		else
		{
			if(MousePos.y > PosY)
				PostMessage(hwTarget, WM_VSCROLL, SB_LINEUP, (LPARAM)SearchScrollBar(hwTarget, SBS_VERT));
			else
				PostMessage(hwTarget, WM_VSCROLL, SB_LINEDOWN, (LPARAM)SearchScrollBar(hwTarget, SBS_VERT));
		}
		MousePos.y = RealPos.y;
	}
	else
	{
		MousePos.y += (MousePos.y - PosY);
	}
}

void HitTestCheck(int x, int y, HWND hwnd, UINT wHitTestCode)
{
	//Windows7x64ƁA̕GNXv[Ƒ
	TCHAR szClassName[1024];
	LV_HITTESTINFO LVHit = {0};
	TV_HITTESTINFO TVHit = {0};

	TargetHitTestCode = wHitTestCode;

#ifdef _WIN64
#else
	if(Wow64Process)
	{
		ListViewHitTestCode = LVHit.flags;
		TreeViewHitTestCode = TVHit.flags;
		return;
	}
#endif	//_WIN64
	GetClassName(hwnd, szClassName, 1024);

	if(ListViewHitTestCodeFlag && lstrcmpi(szClassName, WC_LISTVIEW)==0)
	{
		LVHit.pt.x = x;
		LVHit.pt.y = y;
		ScreenToClient(hwnd, &LVHit.pt);
		ListView_HitTest(hwnd, &LVHit);
	}
	ListViewHitTestCode = LVHit.flags;

	if(TreeViewHitTestCodeFlag && lstrcmpi(szClassName, WC_TREEVIEW)==0)
	{
		TVHit.pt.x = x;
		TVHit.pt.y = y;
		ScreenToClient(hwnd, &TVHit.pt);
		TreeView_HitTest(hwnd, &TVHit);
	}
	TreeViewHitTestCode = TVHit.flags;
}

BOOL GetFileNameFromHwnd(HWND hWnd, LPTSTR lpszFileName, DWORD nSize)
{
	BOOL bResult = FALSE;
	DWORD dwProcessId;
	HANDLE hProcess;

	GetWindowThreadProcessId(hWnd, &dwProcessId);

	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, dwProcessId);
	if(hProcess)
	{
		HMODULE hModule;
		DWORD dwNeed;

		if(EnumProcessModules(hProcess, &hModule, sizeof(hModule), &dwNeed))
		{
			if(GetModuleFileNameEx(hProcess, hModule, lpszFileName, nSize))
				bResult = TRUE;
		}

		if(bResult==FALSE)
		{
			//Vista or later
			typedef BOOL (WINAPI *LPQUERYFULLPROCESSIMAGENAMEA)(HANDLE hProcess, DWORD dwFlags, LPSTR lpExeName, PDWORD lpdwSize);
			typedef BOOL (WINAPI *LPQUERYFULLPROCESSIMAGENAMEW)(HANDLE hProcess, DWORD dwFlags, LPWSTR lpExeName, PDWORD lpdwSize);
			LPQUERYFULLPROCESSIMAGENAMEA QueryFullProcessImageNameA = (LPQUERYFULLPROCESSIMAGENAMEA)GetProcAddress(GetModuleHandle(TEXT("kernel32.dll")), "QueryFullProcessImageNameA");
			LPQUERYFULLPROCESSIMAGENAMEW QueryFullProcessImageNameW = (LPQUERYFULLPROCESSIMAGENAMEW)GetProcAddress(GetModuleHandle(TEXT("kernel32.dll")), "QueryFullProcessImageNameW");
#ifdef UNICODE
#define QueryFullProcessImageName QueryFullProcessImageNameW
#else
#define QueryFullProcessImageName QueryFullProcessImageNameA
#endif
			DWORD dwSize = nSize;
			if(QueryFullProcessImageName)
				bResult = QueryFullProcessImageName(hProcess, 0, lpszFileName, &dwSize);
		}

		CloseHandle(hProcess);
	}

	if(bResult==FALSE)
	{
		HANDLE hProcessSnap;

		hProcessSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
		if(hProcessSnap!=INVALID_HANDLE_VALUE)
		{
			PROCESSENTRY32 pe32;

			pe32.dwSize = sizeof(PROCESSENTRY32);
			if(Process32First(hProcessSnap, &pe32))
			{
				do{
					if(dwProcessId==pe32.th32ProcessID)
					{
						lstrcpyn(lpszFileName, pe32.szExeFile, nSize);
						bResult = TRUE;
						break;
					}
				}while(Process32Next(hProcessSnap, &pe32));
			}
			CloseHandle(hProcessSnap);
		}
	}
	return bResult;
}

//}EXtbÑvV[W
LRESULT CALLBACK MouseHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	PMOUSEHOOKSTRUCT mousehooks = (PMOUSEHOOKSTRUCT)lParam;
	BYTE Press_X_Button = 0;
	BOOL New_X_Button_1, New_X_Button_2;
	UINT X_Button_Code = 0x0000;
#ifdef _WIN64
#else
	BOOL x86APP;
#endif

	if(nCode==HC_ACTION)
	{
		switch(wParam)
		{
		case WM_XBUTTONDOWN:
		case WM_NCXBUTTONDOWN:
		case WM_XBUTTONDBLCLK:
		case WM_NCXBUTTONDBLCLK:
		case WM_XBUTTONUP:
		case WM_NCXBUTTONUP:
			New_X_Button_1 = GetAsyncKeyState( VK_XBUTTON1 ) & 0x8000;
			New_X_Button_2 = GetAsyncKeyState( VK_XBUTTON2 ) & 0x8000;
			if(!X_Button_1 && New_X_Button_1)
				Press_X_Button = 1;
			else if(!X_Button_2 && New_X_Button_2)
				Press_X_Button = 2;
			else if(New_X_Button_1)
				Press_X_Button = 1;
			else if(New_X_Button_2)
				Press_X_Button = 2;
			X_Button_1 = New_X_Button_1;
			X_Button_2 = New_X_Button_2;
			break;
		}

		if(HookFlag)
		{
			switch(wParam)
			{
			case WM_LBUTTONDOWN:
			case WM_NCLBUTTONDOWN:
			case WM_MBUTTONDOWN:
			case WM_NCMBUTTONDOWN:
			case WM_RBUTTONDOWN:
			case WM_NCRBUTTONDOWN:
			case WM_LBUTTONDBLCLK:
			case WM_NCLBUTTONDBLCLK:
			case WM_MBUTTONDBLCLK:
			case WM_NCMBUTTONDBLCLK:
			case WM_RBUTTONDBLCLK:
			case WM_NCRBUTTONDBLCLK:
				if(hwTarget == NULL)
				{
#ifdef _WIN64
#else
					if(Wow64Process)//wow64̃bZ[WEƂƂ肠݂
					{
						if(IsWow64Process(mousehooks->hwnd, &x86APP))
						{
						}
						else
						{
							if(x86APP == FALSE)
								return CallNextHookEx(NextMouseHook, nCode, wParam, lParam);
						}
					}
#endif	//_WIN64
					HitTestCheck(mousehooks->pt.x, mousehooks->pt.y, mousehooks->hwnd, mousehooks->wHitTestCode);
					hwTarget = mousehooks->hwnd;
					SendMessage(CallWnd, MAUHOOK_MSG, wParam, (LPARAM)hwTarget);
				}
				else
				{
					PostMessage(CallWnd, MAUHOOK_MSG, wParam, 0);
				}
			case WM_LBUTTONUP:
			case WM_NCLBUTTONUP:
			case WM_MBUTTONUP:
			case WM_NCMBUTTONUP:
			case WM_RBUTTONUP:
			case WM_NCRBUTTONUP:
				FreeScrollFlag = FALSE;
				if(ButtonFlag)
					return TRUE;
				break;
			case WM_XBUTTONDOWN:
			case WM_NCXBUTTONDOWN:
			case WM_XBUTTONDBLCLK:
			case WM_NCXBUTTONDBLCLK:
				switch(wParam)
				{
				case WM_XBUTTONDOWN:
				case WM_NCXBUTTONDOWN:
					if(Press_X_Button == 1)
						X_Button_Code = WM_XBUTTON1DOWN;
					else if(Press_X_Button == 2)
						X_Button_Code = WM_XBUTTON2DOWN;
					break;
				case WM_XBUTTONDBLCLK:
				case WM_NCXBUTTONDBLCLK:
					if(Press_X_Button == 1)
						X_Button_Code = WM_XBUTTON1DBLCLK;
					else if(Press_X_Button == 2)
						X_Button_Code = WM_XBUTTON2DBLCLK;
					break;
				}

				if(hwTarget == NULL)
				{
					HitTestCheck(mousehooks->pt.x, mousehooks->pt.y, mousehooks->hwnd, mousehooks->wHitTestCode);
					hwTarget = mousehooks->hwnd;
					SendMessage(CallWnd, MAUHOOK_MSG, X_Button_Code, (LPARAM)hwTarget);
				}
				else
				{
					PostMessage(CallWnd, MAUHOOK_MSG, X_Button_Code, 0);
				}
			case WM_XBUTTONUP:
			case WM_NCXBUTTONUP:
				FreeScrollFlag = FALSE;
				if(ButtonFlag)
					return TRUE;
				break;
			case WM_NCMOUSEMOVE:
			case WM_MOUSEMOVE:
				HitTestCheck(mousehooks->pt.x, mousehooks->pt.y, mousehooks->hwnd, mousehooks->wHitTestCode);
				SendMessage(CallWnd, MAUHOOK_MSG, 0, 0);
				//	if(ButtonFlag == TRUE) return TRUE;//AutoCADł̕s
				break;
			default:
				break;
			}
		}
	}
	return CallNextHookEx(NextMouseHook, nCode, wParam, lParam);
}

LRESULT CALLBACK MessageHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	MSG *msg = (MSG *)lParam;

	if(nCode==HC_ACTION)
	{
		switch(Cursor)
		{
		case 0:
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			Cursor = 3;
			break;
		case 1:
			SetCursor(hcursor_wait);
			break;
		case 2:
			SetCursor(hcursor_gesture);
			break;
		}

		if(HookFlag)
		{
			if(msg->message == uMsgSetTarget)
			{
				SetTargetFlag = FALSE;
				SetFocus(msg->hwnd);
				msg->message = WM_NULL;
				msg->wParam = 0;
				msg->lParam = 0;
				return FALSE;
			}
			if(msg->message == uMsgGetFocus)
			{
				GetWindowFocusFlag = FALSE;
				WindowFocus = GetFocus();
				msg->message = WM_NULL;
				msg->wParam = 0;
				msg->lParam = 0;
				return FALSE;
			}
		}
	}
	return CallNextHookEx(NextMessageHook, nCode, wParam, lParam);
}

LRESULT CALLBACK ButtonSearchHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	CWPSTRUCT *pcwp = (CWPSTRUCT *)lParam;
	TCHAR buffer[20];

	if(nCode==HC_ACTION)
	{
		if(pcwp->message==WM_COMMAND)
		{
			UnhookWindowsHookEx(NextButtonSearchHook);
			ButtonSearchHook = FALSE;
			wsprintf(buffer, TEXT("%d"), LOWORD(pcwp->wParam));
			SendMessage(CallDlg1, WM_SETTEXT, 0, (LPARAM)buffer);
		}
	}
	return CallNextHookEx(NextButtonSearchHook, nCode, wParam, lParam);
}

LRESULT CALLBACK LowLevelMouseHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	PMSLLHOOKSTRUCT mousehooks = (PMSLLHOOKSTRUCT)lParam;
	HWND RedirectTarget;
	UINT WheelMessage;

	if(nCode==HC_ACTION)
	{
		switch(wParam)
		{
		case WM_LBUTTONDOWN:
		case WM_NCLBUTTONDOWN:
		case WM_MBUTTONDOWN:
		case WM_NCMBUTTONDOWN:
		case WM_RBUTTONDOWN:
		case WM_NCRBUTTONDOWN:
		case WM_LBUTTONDBLCLK:
		case WM_NCLBUTTONDBLCLK:
		case WM_MBUTTONDBLCLK:
		case WM_NCMBUTTONDBLCLK:
		case WM_RBUTTONDBLCLK:
		case WM_NCRBUTTONDBLCLK:
			break;
		case WM_LBUTTONUP:
		case WM_NCLBUTTONUP:
		case WM_MBUTTONUP:
		case WM_NCMBUTTONUP:
		case WM_RBUTTONUP:
		case WM_NCRBUTTONUP:
			break;
		case WM_XBUTTONDOWN:
		case WM_NCXBUTTONDOWN:
		case WM_XBUTTONDBLCLK:
		case WM_NCXBUTTONDBLCLK:
		case WM_XBUTTONUP:
		case WM_NCXBUTTONUP:
			break;
		case WM_NCMOUSEMOVE:
		case WM_MOUSEMOVE:
			if(KuruKuruFlag)
			{
				SendMessage(CallWnd, KURUKURUHOOK_MSG, mousehooks->pt.x, mousehooks->pt.y);
				return TRUE;
			}
			else if(FreeScrollFlag)
			{
				SendMessage(CallWnd, FREESCROLL_MSG, mousehooks->pt.x, mousehooks->pt.y);
				return TRUE;
			}
			else if(ScrollFlag)
			{
				if(mousehooks->pt.x != MousePos.x || mousehooks->pt.y != MousePos.y)
					MouseScroll(mousehooks->pt.x, mousehooks->pt.y);
				return TRUE;
			}
			else
			{
//				HitTestCheck(MAKELPARAM(mousehooks->pt.x, mousehooks->pt.y));
				SendMessage(CallWnd, MAUHOOK_MSG, 0, 0);
			}
			break;
		case WM_MOUSEWHEEL:
			if((SHORT)HIWORD(mousehooks->mouseData) > 0)
				WheelMessage = WM_MOUSEWHEEL_UP;
			else
				WheelMessage = WM_MOUSEWHEEL_DOWN;

			if(hwTarget==NULL)
			{
				hwTarget = WindowFromPoint(mousehooks->pt);
				SendMessage(CallWnd, MAUHOOK_MSG, WheelMessage, (LPARAM)hwTarget);
			}
			else
			{
				PostMessage(CallWnd, MAUHOOK_MSG, WM_MOUSEWHEEL, (LPARAM)(SHORT)HIWORD(mousehooks->mouseData));
			}

			if(ButtonFlag)
			{
				return TRUE;
			}
			else
			{
				RedirectTarget = WindowFromPoint(mousehooks->pt);
				if (SendMessage(CallWnd, FREESCROLLSEARCH_MSG, (WPARAM)RedirectTarget, 0))
				{
					if(WheelActiveFlag)
					{
						BringWindowToTop(GetRootWindow(RedirectTarget));
						SetTargetFlag = TRUE;
						PostMessage(RedirectTarget, uMsgSetTarget, 0, 0);
					}

					if(WheelMessage==WM_MOUSEWHEEL_DOWN)
					{
						FreeScrollFlag = TRUE;
						SendMessage(CallWnd, FREESCROLLINIT_MSG, (WPARAM)RedirectTarget, 0);
					}
					else
					{
						FreeScrollFlag = FALSE;
					}
					return TRUE;
				}

				if(WheelRedirectFlag)
				{
					if(GetForegroundWindow()!=RedirectTarget)
					{
						if(SendMessage(CallWnd, WHEELREDIRECT_MSG, (WPARAM)RedirectTarget, 0))
						{
							if(WheelActiveFlag)
							{
								BringWindowToTop(GetRootWindow(RedirectTarget));
								SetTargetFlag = TRUE;
								PostMessage(RedirectTarget, uMsgSetTarget, 0, 0);
							}
							PostMessage(RedirectTarget, WM_MOUSEWHEEL, mousehooks->mouseData, MAKELPARAM(mousehooks->pt.x, mousehooks->pt.y));
							return TRUE;
						}
					}
				}
			}
			break;
		case WM_MOUSEHWHEEL:
			if((SHORT)HIWORD(mousehooks->mouseData) < 0)
				WheelMessage = WM_MOUSEWHEEL_LEFT;
			else
				WheelMessage = WM_MOUSEWHEEL_RIGHT;

			if(hwTarget==NULL)
			{
				hwTarget = WindowFromPoint(mousehooks->pt);
				SendMessage(CallWnd, MAUHOOK_MSG, WheelMessage, (LPARAM)hwTarget);
			}
			else
			{
				PostMessage(CallWnd, MAUHOOK_MSG, WM_MOUSEHWHEEL, (LPARAM)(SHORT)HIWORD(mousehooks->mouseData));
			}

			if(ButtonFlag)
			{
				return TRUE;
			}
			else
			{
				RedirectTarget = WindowFromPoint(mousehooks->pt);
				if(WheelRedirectFlag)
				{
					if(GetForegroundWindow()!=RedirectTarget)
					{
						if(SendMessage(CallWnd, WHEELREDIRECT_MSG, (WPARAM)RedirectTarget, 0))
						{
							if(WheelActiveFlag)
							{
								BringWindowToTop(GetRootWindow(RedirectTarget));
								SetTargetFlag = TRUE;
								PostMessage(RedirectTarget, uMsgSetTarget, 0, 0);
							}
							PostMessage(RedirectTarget, WM_MOUSEHWHEEL, mousehooks->mouseData, MAKELPARAM(mousehooks->pt.x, mousehooks->pt.y));
							return TRUE;
						}
					}
				}
			}
			break;
		}

		switch(WindowHook)
		{
		case 1:
			if(wParam==WM_LBUTTONDOWN || wParam==WM_NCLBUTTONDOWN)
			{
				LONG_PTR TempID;

				WindowHook = 0;
				GetFileNameFromHwnd(WindowFromPoint(mousehooks->pt), TargetPath,_MAX_PATH);
				GetClassName(WindowFromPoint(mousehooks->pt), TargetClass, MAX_CLASSNAME);
				SetLastError(0);
				TempID = GetWindowLongPtr(WindowFromPoint(mousehooks->pt), GWLP_ID);
				if(!GetLastError())
					wsprintf(TargetID, TEXT("%d"), GetWindowLongPtr(WindowFromPoint(mousehooks->pt), GWLP_ID));
				else
					lstrcpy(TargetID, TEXT("\0"));
				PostMessage(CallDlg1, MAUHOOK_MSG, 0, 0);
			}
			break;
		case 2:
			if(wParam==WM_LBUTTONDOWN && SendMessage(WindowFromPoint(mousehooks->pt), WM_NCHITTEST, 0, MAKELPARAM(mousehooks->pt.x, mousehooks->pt.y))==HTCAPTION)
			{
				RECT TargetRect;
				TCHAR buffer[20];

				WindowHook = 0;
				GetWindowRect(GetRootWindow(WindowFromPoint(mousehooks->pt)), &TargetRect);
				wsprintf(buffer, TEXT("%d"), TargetRect.right - TargetRect.left);
				SendMessage(CallDlg1, WM_SETTEXT, 0, (LPARAM)buffer);
				wsprintf(buffer, TEXT("%d"), TargetRect.bottom - TargetRect.top);
				SendMessage(CallDlg2, WM_SETTEXT, 0, (LPARAM)buffer);
			}
			break;
		case 3:
			if(wParam==WM_LBUTTONDOWN && SendMessage(WindowFromPoint(mousehooks->pt), WM_NCHITTEST, 0, MAKELPARAM(mousehooks->pt.x, mousehooks->pt.y))==HTCAPTION)
			{
				RECT TargetRect;
				TCHAR buffer[20];

				WindowHook = 0;
				GetWindowRect(GetRootWindow(WindowFromPoint(mousehooks->pt)), &TargetRect);
				wsprintf(buffer, TEXT("%d"), TargetRect.left);
				SendMessage(CallDlg1, WM_SETTEXT, 0, (LPARAM)buffer);
				wsprintf(buffer, TEXT("%d"), TargetRect.top);
				SendMessage(CallDlg2, WM_SETTEXT, 0, (LPARAM)buffer);
			}
			break;
		case 4:
			if(wParam==WM_RBUTTONDOWN || wParam==WM_NCRBUTTONDOWN)
			{
				RECT TargetRect;
				TCHAR buffer[20];

				WindowHook = 0;
				GetWindowRect(GetRootWindow(WindowFromPoint(mousehooks->pt)), &TargetRect);
				wsprintf(buffer, TEXT("%d"), mousehooks->pt.x - TargetRect.left);
				SendMessage(CallDlg1, WM_SETTEXT, 0, (LPARAM)buffer);
				wsprintf(buffer, TEXT("%d"), mousehooks->pt.y - TargetRect.top);
				SendMessage(CallDlg2, WM_SETTEXT, 0, (LPARAM)buffer);
			}
			break;
		}
	}
	return CallNextHookEx(NextLowLevelHook, nCode, wParam, lParam);
}

void SetCursorNumber(int CursorNumber)
{
	if(Cursor < 4)
		Cursor = CursorNumber;
}

void SetCursorHandle(LPTSTR GestureCursor, LPTSTR WaitCursor, BOOL CursorChange)
{
	if(CursorChange)
	{	
		if(hcursor_gesture != NULL)
			DestroyCursor(hcursor_gesture);

		if(hcursor_wait != NULL)
			DestroyCursor(hcursor_wait);

		if(GetFileAttributes(GestureCursor) != 0xFFFFFFFF)
			hcursor_gesture = LoadCursorFromFile(GestureCursor);
		else
			hcursor_gesture = LoadCursor(NULL, IDC_CROSS);

		if(GetFileAttributes(WaitCursor) != 0xFFFFFFFF)
			hcursor_wait = LoadCursorFromFile(WaitCursor);
		else
			hcursor_wait = LoadCursor(NULL, IDC_APPSTARTING);
		Cursor = 3;
	}
	else
		Cursor = 4;
}

void SetButtonFlag(BOOL Flag)
{
	ButtonFlag = Flag;
}

void SetHookFlag(BOOL fEnable)
{
	HookFlag = fEnable;
}

void ResetButtonFlag()
{
	HookFlag = TRUE;
	hwTarget = NULL;
	ButtonFlag = FALSE;
	TargetHitTestCode = NO_HITTEST;
	ScrollFlag = FALSE;
}

//tbN̊Jn
void SetMouseHook(HWND hWnd)
{
	CallWnd = hWnd;

	//듮h~邽߂Ƃ肠
	HookFlag = TRUE;
	hwTarget = NULL;
	ButtonFlag = FALSE;

	X_Button_1 = GetAsyncKeyState( VK_XBUTTON1 ) & 0x8000;
	X_Button_2 = GetAsyncKeyState( VK_XBUTTON2 ) & 0x8000;

	uMsgSetTarget = RegisterWindowMessage(TEXT("MauSujiMsgSetTarget"));
	uMsgGetFocus = RegisterWindowMessage(TEXT("MauSujiMsgGetFocus"));

	//tbNJn
	NextMouseHook = SetWindowsHookEx(WH_MOUSE, MouseHookProc, hInstDLL, 0);
	NextMessageHook = SetWindowsHookEx(WH_GETMESSAGE, MessageHookProc, hInstDLL, 0);
	NextLowLevelHook = SetWindowsHookEx(WH_MOUSE_LL, LowLevelMouseHookProc, hInstDLL, 0);

#ifdef _WIN64
#else
	// OS ǂ CPU A[LeN`pȂ̂
	IsWow64Process(GetCurrentProcess(), &Wow64Process);
#endif	//_WIN64
}

BOOL CALLBACK PostNullProc(HWND hWnd, LPARAM lParam)
{
	PostMessage(hWnd, WM_NULL, 0, 0);
	return TRUE;
}

//tbN̏I
void MouseUnHook(void)
{
	if(NextMouseHook)
		UnhookWindowsHookEx(NextMouseHook);
	if(NextMessageHook)
		UnhookWindowsHookEx(NextMessageHook);
	if(NextLowLevelHook)
		UnhookWindowsHookEx(NextLowLevelHook);
	EnumWindows(PostNullProc, NULL);
}

void SetButtonSearchHook(HWND hDlgItem)
{
	if(!ButtonSearchHook)
	{
		ButtonSearchHook = TRUE;
		CallDlg1 = hDlgItem;
		NextButtonSearchHook = SetWindowsHookEx(WH_CALLWNDPROC, ButtonSearchHookProc, hInstDLL, 0);
	}
}

void ButtonSearchUnHook(void)
{
	if(NextButtonSearchHook)
		UnhookWindowsHookEx(NextButtonSearchHook);
}

void SetWindowHook(HWND hDlg1, HWND hDlg2, int HookType)
{
	if(WindowHook == 0)
	{
		WindowHook = HookType;
		CallDlg1 = hDlg1;
		CallDlg2 = hDlg2;
	}
}

void WindowUnHook(void)
{
	WindowHook = 0;
}

LRESULT CALLBACK KeyBoardHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if(nCode >= 0 && GetFocus() == hSendKeyCombo)
	{
		if(GetKeyState( (int)wParam ) & 0x8000)
			SendMessage(hCommandDialog, WM_KEYBOARD_MSG, wParam, lParam);
		return TRUE;
	}
	return CallNextHookEx(KeyBoardHook, nCode, wParam, lParam);
}

void SetSendKeyComboHook(HWND hDlg, HWND hCmb)
{
	hCommandDialog = hDlg;
	hSendKeyCombo = hCmb;
	KeyBoardHook = SetWindowsHookEx(WH_KEYBOARD, KeyBoardHookProc, hInstDLL, 0);
}

void SetSendKeyComboUnHook(void)
{
	if(KeyBoardHook)
		UnhookWindowsHookEx(KeyBoardHook);
}

void GetFileName(LPTSTR FileName, LPTSTR ClassName, LPTSTR ControlID)
{
	lstrcpy(FileName, TargetPath);
	lstrcpy(ClassName, TargetClass);
	lstrcpy(ControlID, TargetID);
}

void SetTarget()
{
	SetTargetFlag = TRUE;
	PostMessage(hwTarget, uMsgSetTarget, 0, 0);
	Sleep(0);
}

int GetTargetHitTestCode(int Flag)
{
	switch(Flag)
	{
	case 1:
		return TargetHitTestCode;
	case 2:
		return ListViewHitTestCode;
	case 3:
		return TreeViewHitTestCode;
	default:
		return 0;
	}
}

void SetListViewHitTestFlag(BOOL fEnable)
{
	ListViewHitTestCodeFlag = fEnable;
}

void SetTreeViewHitTestFlag(BOOL fEnable)
{
	TreeViewHitTestCodeFlag = fEnable;
}

HWND GetTargetHandle()
{
	return hwTarget;
}

HWND GetWindowFocus(HWND hWnd)
{
	GetWindowFocusFlag = TRUE;
	PostMessage(hWnd, uMsgGetFocus, 0, 0);
	Sleep(0);
	return WindowFocus;
}

void SetWheelRedirectFlag(BOOL Flag)
{
	WheelRedirectFlag = Flag;
}

HWND GetRootWindow(HWND hWnd)
{
	return GetAncestor(hWnd, GA_ROOT);
}

void SetMouseScroll(int S_Line, int S_Page)
{
	ScrollLine = S_Line;
	ScrollPage = S_Page;
	ScrollFlag = TRUE;
	GetCursorPos(&MousePos);
	return;
}

void SetWheelActiveFlag(BOOL Flag)
{
	WheelActiveFlag = Flag;
}

void SetKuruKuruFlag(BOOL Flag)
{
	KuruKuruFlag = Flag;
}
